/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IPagingMapFactory.java,v 1.4 2005/02/16 22:21:22 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.loaders.util;

import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

/**
 * @author slavescu
 */
public interface IPagingMapFactory {
	public abstract EMap createPagingMap(
		EObject owner,
		EStructuralFeature eStructuralFeature);
	public abstract EMap createPagingMap(
		Class dataClass,
		EObject owner,
		int featureID);
	public abstract EMap createPagingMap(
		Class dataClass,
		EObject owner,
		int featureID,
		int inverseFeatureID);
	public abstract void setPagingSize(int size);
	public abstract int getPagingSize();
}