/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: OutputterType.java,v 1.9 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.outputter;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 *      The basic outputter types that are understood
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterType()
 * @model
 * @generated
 */
public final class OutputterType extends AbstractEnumerator {
	/**
	 * The '<em><b>Standard Out Outputter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STANDARD_OUT_OUTPUTTER_LITERAL
	 * @model name="StandardOutOutputter"
	 * @generated
	 * @ordered
	 */
	public static final int STANDARD_OUT_OUTPUTTER = 0;

	/**
	 * The '<em><b>Single File Outputter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SINGLE_FILE_OUTPUTTER_LITERAL
	 * @model name="SingleFileOutputter"
	 * @generated
	 * @ordered
	 */
	public static final int SINGLE_FILE_OUTPUTTER = 1;

	/**
	 * The '<em><b>Logging Agent Outputter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LOGGING_AGENT_OUTPUTTER_LITERAL
	 * @model name="LoggingAgentOutputter"
	 * @generated
	 * @ordered
	 */
	public static final int LOGGING_AGENT_OUTPUTTER = 2;

	/**
	 * The '<em><b>Notification Outputter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NOTIFICATION_OUTPUTTER_LITERAL
	 * @model name="NotificationOutputter"
	 * @generated
	 * @ordered
	 */
	public static final int NOTIFICATION_OUTPUTTER = 3;

	/**
	 * The '<em><b>Undeclared</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNDECLARED_LITERAL
	 * @model name="undeclared"
	 * @generated
	 * @ordered
	 */
	public static final int UNDECLARED = 4;

	/**
	 * The '<em><b>Standard Out Outputter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Standard Out Outputter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STANDARD_OUT_OUTPUTTER
	 * @generated
	 * @ordered
	 */
	public static final OutputterType STANDARD_OUT_OUTPUTTER_LITERAL = new OutputterType(STANDARD_OUT_OUTPUTTER, "StandardOutOutputter");

	/**
	 * The '<em><b>Single File Outputter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Single File Outputter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SINGLE_FILE_OUTPUTTER
	 * @generated
	 * @ordered
	 */
	public static final OutputterType SINGLE_FILE_OUTPUTTER_LITERAL = new OutputterType(SINGLE_FILE_OUTPUTTER, "SingleFileOutputter");

	/**
	 * The '<em><b>Logging Agent Outputter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Logging Agent Outputter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LOGGING_AGENT_OUTPUTTER
	 * @generated
	 * @ordered
	 */
	public static final OutputterType LOGGING_AGENT_OUTPUTTER_LITERAL = new OutputterType(LOGGING_AGENT_OUTPUTTER, "LoggingAgentOutputter");

	/**
	 * The '<em><b>Notification Outputter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Notification Outputter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NOTIFICATION_OUTPUTTER
	 * @generated
	 * @ordered
	 */
	public static final OutputterType NOTIFICATION_OUTPUTTER_LITERAL = new OutputterType(NOTIFICATION_OUTPUTTER, "NotificationOutputter");

	/**
	 * The '<em><b>Undeclared</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Undeclared</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNDECLARED
	 * @generated
	 * @ordered
	 */
	public static final OutputterType UNDECLARED_LITERAL = new OutputterType(UNDECLARED, "undeclared");

	/**
	 * An array of all the '<em><b>Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final OutputterType[] VALUES_ARRAY =
		new OutputterType[] {
			STANDARD_OUT_OUTPUTTER_LITERAL,
			SINGLE_FILE_OUTPUTTER_LITERAL,
			LOGGING_AGENT_OUTPUTTER_LITERAL,
			NOTIFICATION_OUTPUTTER_LITERAL,
			UNDECLARED_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static OutputterType get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			OutputterType result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Type</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static OutputterType get(int value) {
		switch (value) {
			case STANDARD_OUT_OUTPUTTER: return STANDARD_OUT_OUTPUTTER_LITERAL;
			case SINGLE_FILE_OUTPUTTER: return SINGLE_FILE_OUTPUTTER_LITERAL;
			case LOGGING_AGENT_OUTPUTTER: return LOGGING_AGENT_OUTPUTTER_LITERAL;
			case NOTIFICATION_OUTPUTTER: return NOTIFICATION_OUTPUTTER_LITERAL;
			case UNDECLARED: return UNDECLARED_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private OutputterType(int value, String name) {
		super(value, name);
	}

} //OutputterType
