/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: SubstitutionRuleType.java,v 1.9 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Substitution Rule Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getMatch <em>Match</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getPositions <em>Positions</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitute <em>Substitute</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitutionExtensionClass <em>Substitution Extension Class</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getTimeFormat <em>Time Format</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#isUseBuiltInFunction <em>Use Built In Function</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType()
 * @model 
 * @generated
 */
public interface SubstitutionRuleType extends EObject{
	/**
	 * Returns the value of the '<em><b>Match</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 								A match pattern specified as a regular expression.
	 * 							
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Match</em>' attribute.
	 * @see #setMatch(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType_Match()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getMatch();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getMatch <em>Match</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Match</em>' attribute.
	 * @see #getMatch()
	 * @generated
	 */
	void setMatch(String value);

	/**
	 * Returns the value of the '<em><b>Positions</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 								An optional specification of fields, either named or by position, 
	 * 								within a record.
	 * 							
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Positions</em>' attribute.
	 * @see #setPositions(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType_Positions()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getPositions();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getPositions <em>Positions</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Positions</em>' attribute.
	 * @see #getPositions()
	 * @generated
	 */
	void setPositions(String value);

	/**
	 * Returns the value of the '<em><b>Substitute</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 								A specification of substitution values.
	 * 							
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Substitute</em>' attribute.
	 * @see #setSubstitute(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType_Substitute()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getSubstitute();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitute <em>Substitute</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Substitute</em>' attribute.
	 * @see #getSubstitute()
	 * @generated
	 */
	void setSubstitute(String value);

	/**
	 * Returns the value of the '<em><b>Substitution Extension Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 								An optional specification of a user class to perform substitution 
	 * 								logic.
	 * 							
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Substitution Extension Class</em>' attribute.
	 * @see #setSubstitutionExtensionClass(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType_SubstitutionExtensionClass()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getSubstitutionExtensionClass();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitutionExtensionClass <em>Substitution Extension Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Substitution Extension Class</em>' attribute.
	 * @see #getSubstitutionExtensionClass()
	 * @generated
	 */
	void setSubstitutionExtensionClass(String value);

	/**
	 * Returns the value of the '<em><b>Time Format</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 								For time values, an optional specification of a Java time format that 
	 * 								will be used to parse the substitution value to produce a time in 
	 * 								milliseconds.
	 * 							
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Time Format</em>' attribute.
	 * @see #setTimeFormat(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType_TimeFormat()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getTimeFormat();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getTimeFormat <em>Time Format</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Format</em>' attribute.
	 * @see #getTimeFormat()
	 * @generated
	 */
	void setTimeFormat(String value);

	/**
	 * Returns the value of the '<em><b>Use Built In Function</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 								A boolean indicator of whether a parser built in function be used 
	 * 								to generate the value.
	 * 							
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Use Built In Function</em>' attribute.
	 * @see #isSetUseBuiltInFunction()
	 * @see #unsetUseBuiltInFunction()
	 * @see #setUseBuiltInFunction(boolean)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getSubstitutionRuleType_UseBuiltInFunction()
	 * @model unique="false" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
	boolean isUseBuiltInFunction();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#isUseBuiltInFunction <em>Use Built In Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Use Built In Function</em>' attribute.
	 * @see #isSetUseBuiltInFunction()
	 * @see #unsetUseBuiltInFunction()
	 * @see #isUseBuiltInFunction()
	 * @generated
	 */
	void setUseBuiltInFunction(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#isUseBuiltInFunction <em>Use Built In Function</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetUseBuiltInFunction()
	 * @see #isUseBuiltInFunction()
	 * @see #setUseBuiltInFunction(boolean)
	 * @generated
	 */
	void unsetUseBuiltInFunction();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#isUseBuiltInFunction <em>Use Built In Function</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Use Built In Function</em>' attribute is set.
	 * @see #unsetUseBuiltInFunction()
	 * @see #isUseBuiltInFunction()
	 * @see #setUseBuiltInFunction(boolean)
	 * @generated
	 */
	boolean isSetUseBuiltInFunction();

} // SubstitutionRuleType
