/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CBEContextDataElement.java,v 1.9 2005/05/09 05:05:15 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.cbe;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Context Data Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The Context Data Element provides data that is used ot establish the 
 * envrionment of an event. This data is intended to be used when post processing 
 * the model in order to associate or "correlate" multiple events together.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextId <em>Context Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextValue <em>Context Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEContextDataElement()
 * @model 
 * @generated
 */
public interface CBEContextDataElement extends EObject{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Context Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Context Id</em>' attribute.
	 * @see #setContextId(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEContextDataElement_ContextId()
	 * @model 
	 * @generated
	 */
	String getContextId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextId <em>Context Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Context Id</em>' attribute.
	 * @see #getContextId()
	 * @generated
	 */
	void setContextId(String value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEContextDataElement_Type()
	 * @model 
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEContextDataElement_Name()
	 * @model 
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Context Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Context Value</em>' attribute.
	 * @see #setContextValue(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEContextDataElement_ContextValue()
	 * @model 
	 * @generated
	 */
	String getContextValue();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextValue <em>Context Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Context Value</em>' attribute.
	 * @see #getContextValue()
	 * @generated
	 */
	void setContextValue(String value);

} // CBEContextDataElement
