/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CBEExtendedDataElement.java,v 1.10 2005/05/09 05:05:15 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.cbe;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Extended Data Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The ExtendedDataElement class provides a name-value pair for a Common Base 
 * Eevent. For example you may choose to have a name-value pair to provide return 
 * error code, extended problem situation description, or provide any additional 
 * data for the consumer of the event. 
 * Token names may be referenced by correlation rules, however the 
 * ContextDataElement's prime purpose is ot hold data used for correlation. The 
 * support of this class relieves management tools of the need to be able to 
 * tokenize application specific artifacts.  The token definitions are assumed to 
 * be specific to a resource. The data format is assumed to be in big endian.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getHexValue <em>Hex Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEExtendedDataElement()
 * @model 
 * @generated
 */
public interface CBEExtendedDataElement extends CBEDefaultElement{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEExtendedDataElement_Type()
	 * @model 
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

	/**
	 * Returns the value of the '<em><b>Hex Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Hex Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Hex Value</em>' attribute.
	 * @see #setHexValue(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEExtendedDataElement_HexValue()
	 * @model 
	 * @generated
	 */
	String getHexValue();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getHexValue <em>Hex Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Hex Value</em>' attribute.
	 * @see #getHexValue()
	 * @generated
	 */
	void setHexValue(String value);

} // CBEExtendedDataElement
