/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CFGCategorySelectionMode.java,v 1.10 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>CFG Category Selection Mode</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategorySelectionMode()
 * @model
 * @generated
 */
public final class CFGCategorySelectionMode extends AbstractEnumerator {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The '<em><b>Enter Value</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ENTER_VALUE_LITERAL
	 * @model name="enterValue"
	 * @generated
	 * @ordered
	 */
	public static final int ENTER_VALUE = 0;

	/**
	 * The '<em><b>Select And Enter Value</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SELECT_AND_ENTER_VALUE_LITERAL
	 * @model name="selectAndEnterValue"
	 * @generated
	 * @ordered
	 */
	public static final int SELECT_AND_ENTER_VALUE = 1;

	/**
	 * The '<em><b>Select Value</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SELECT_VALUE_LITERAL
	 * @model name="selectValue"
	 * @generated
	 * @ordered
	 */
	public static final int SELECT_VALUE = 2;

	/**
	 * The '<em><b>Password</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PASSWORD_LITERAL
	 * @model name="password"
	 * @generated
	 * @ordered
	 */
	public static final int PASSWORD = 3;

	/**
	 * The '<em><b>Enter Value</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Enter Value</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ENTER_VALUE
	 * @generated
	 * @ordered
	 */
	public static final CFGCategorySelectionMode ENTER_VALUE_LITERAL = new CFGCategorySelectionMode(ENTER_VALUE, "enterValue");

	/**
	 * The '<em><b>Select And Enter Value</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Select And Enter Value</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SELECT_AND_ENTER_VALUE
	 * @generated
	 * @ordered
	 */
	public static final CFGCategorySelectionMode SELECT_AND_ENTER_VALUE_LITERAL = new CFGCategorySelectionMode(SELECT_AND_ENTER_VALUE, "selectAndEnterValue");

	/**
	 * The '<em><b>Select Value</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Select Value</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SELECT_VALUE
	 * @generated
	 * @ordered
	 */
	public static final CFGCategorySelectionMode SELECT_VALUE_LITERAL = new CFGCategorySelectionMode(SELECT_VALUE, "selectValue");

	/**
	 * The '<em><b>Password</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Password</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PASSWORD
	 * @generated
	 * @ordered
	 */
	public static final CFGCategorySelectionMode PASSWORD_LITERAL = new CFGCategorySelectionMode(PASSWORD, "password");

	/**
	 * An array of all the '<em><b>CFG Category Selection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final CFGCategorySelectionMode[] VALUES_ARRAY =
		new CFGCategorySelectionMode[] {
			ENTER_VALUE_LITERAL,
			SELECT_AND_ENTER_VALUE_LITERAL,
			SELECT_VALUE_LITERAL,
			PASSWORD_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>CFG Category Selection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>CFG Category Selection Mode</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CFGCategorySelectionMode get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			CFGCategorySelectionMode result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>CFG Category Selection Mode</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CFGCategorySelectionMode get(int value) {
		switch (value) {
			case ENTER_VALUE: return ENTER_VALUE_LITERAL;
			case SELECT_AND_ENTER_VALUE: return SELECT_AND_ENTER_VALUE_LITERAL;
			case SELECT_VALUE: return SELECT_VALUE_LITERAL;
			case PASSWORD: return PASSWORD_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private CFGCategorySelectionMode(int value, String name) {
		super(value, name);
	}

} //CFGCategorySelectionMode
