/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDBDirective.java,v 1.7 2005/02/16 22:21:25 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.internal.sdb;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Directive</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Directives are the actual steps or actions that are recommended for a given 
 * solution.
 * Although not required to be mutually exclusive the description and directive 
 * string are often not both used at the same time.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getDirectiveString <em>Directive String</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getSolutions <em>Solutions</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBDirective()
 * @model 
 * @generated
 */
public interface SDBDirective extends EObject{
	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A directtive has a unique identifier relative to the runtime that owns it.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBDirective_Id()
	 * @model 
	 * @generated
	 */
	String getId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(String value);

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * In the case that the action or directive take the form of a textual instruction for a user, that text would be held in this property. An example might be "power on the server".
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBDirective_Description()
	 * @model 
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Directive String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Directive String</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A directive string is intended to hold a meaningful string for the runtime to use in an automated or at least runtime unique reaction ot the symptom. 
	 * For example the directive may contain a class name that the runtime could load and execute in order to collect more data or automate an adjustment.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Directive String</em>' attribute.
	 * @see #setDirectiveString(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBDirective_DirectiveString()
	 * @model 
	 * @generated
	 */
	String getDirectiveString();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getDirectiveString <em>Directive String</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Directive String</em>' attribute.
	 * @see #getDirectiveString()
	 * @generated
	 */
	void setDirectiveString(String value);

	/**
	 * Returns the value of the '<em><b>Solutions</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.internal.sdb.SDBSolution}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getDirectives <em>Directives</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Solutions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Solutions</em>' reference list.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBDirective_Solutions()
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution#getDirectives
	 * @model type="org.eclipse.hyades.models.internal.sdb.SDBSolution" opposite="directives"
	 * @generated
	 */
	EList getSolutions();

} // SDBDirective
