/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDBSolution.java,v 1.7 2005/02/16 22:21:25 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.internal.sdb;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Solution</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A solution is a action that can be taken to address the symptom. A solution can 
 * take the form of a message to a user or automated actions, and that is all 
 * defined by the directives.
 * Solutions are owned by and unique to a runtime.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getDirectives <em>Directives</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getSymptoms <em>Symptoms</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSolution()
 * @model 
 * @generated
 */
public interface SDBSolution extends EObject{
	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A human readable brief description an answer to the problem. For example a symptom that captures a performance throughput problem may have a solution of "adjust the size fo the thread pool". This solution may be a fix for several different symptoms, and it may be detailed with several directives.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSolution_Description()
	 * @model 
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A solution is unque within a runtime environment.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSolution_Id()
	 * @model 
	 * @generated
	 */
	String getId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(String value);

	/**
	 * Returns the value of the '<em><b>Directives</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.internal.sdb.SDBDirective}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getSolutions <em>Solutions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Directives</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Directives</em>' reference list.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSolution_Directives()
	 * @see org.eclipse.hyades.models.internal.sdb.SDBDirective#getSolutions
	 * @model type="org.eclipse.hyades.models.internal.sdb.SDBDirective" opposite="solutions"
	 * @generated
	 */
	EList getDirectives();

	/**
	 * Returns the value of the '<em><b>Symptoms</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.internal.sdb.SDBSymptom}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getSolutions <em>Solutions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Symptoms</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Symptoms</em>' reference list.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSolution_Symptoms()
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSymptom#getSolutions
	 * @model type="org.eclipse.hyades.models.internal.sdb.SDBSymptom" opposite="solutions"
	 * @generated
	 */
	EList getSymptoms();

} // SDBSolution
