/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IProbeCompileActionDelegateFactory.java,v 1.4 2005/02/16 22:21:28 qiyanli Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.probekit.ui;

import org.eclipse.ui.IObjectActionDelegate;

/**
 * This interface must be implemented by anybody who wants to replace
 * the behavior of the Probekit>Compile context menu action.
 * 
 * There is one method, "create," which must return an instance
 * of a class that implements IObjectActionDelegate. 
 */
public interface IProbeCompileActionDelegateFactory {
	public IObjectActionDelegate create();
}
